SystemOrganization addCategory: #'AL-Tests-Storage'!

ALEntity subclass: #ALBogusEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

!ALBogusEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2012 10:10'!
forTesting
	^ self griffle: $g plonk: $p nuft: $n! !

!ALBogusEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2012 09:58'!
griffle: g plonk: p nuft: n
	^ self basicNew initializeWithGriffle: g plonk: p nuft: n! !

!ALBogusEntity class methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2012 09:30'!
variableNames
	^ #('griffle' 'plonk' 'nuft')! !

!ALBogusEntity methodsFor: 'accessing' stamp: 'cwp 12/31/2012 10:55'!
griffle
	vector ifNil: [vector := ALReadEntity key: key].
	^ vector at: 1
! !

!ALBogusEntity methodsFor: 'accessing' stamp: 'cwp 12/31/2012 10:57'!
griffle: anObject
	vector ifNil: [vector := ALReadEntity key: key].
	^ vector at: 1 put: anObject
! !

!ALBogusEntity methodsFor: 'initialization' stamp: 'cwp 12/31/2012 10:01'!
initializeWithGriffle: g plonk: p nuft: n
	vector := ALVector new: 3.
	self
		griffle: g;
		plonk: p;
		nuft: n.
	key := vector add! !

!ALBogusEntity methodsFor: 'accessing' stamp: 'cwp 12/31/2012 10:55'!
nuft
	vector ifNil: [vector := ALReadEntity key: key].
	^ vector at: 3
! !

!ALBogusEntity methodsFor: 'accessing' stamp: 'cwp 12/31/2012 10:57'!
nuft: anObject
	vector ifNil: [vector := ALReadEntity key: key].
	^ vector at: 3 put: anObject
! !

!ALBogusEntity methodsFor: 'accessing' stamp: 'cwp 12/31/2012 10:55'!
plonk
	vector ifNil: [vector := ALReadEntity key: key].
	^ vector at: 2
! !

!ALBogusEntity methodsFor: 'accessing' stamp: 'cwp 12/31/2012 10:57'!
plonk: anObject
	vector ifNil: [vector := ALReadEntity key: key].
	^ vector at: 2 put: anObject
! !

TestCase subclass: #ALEntityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

!ALEntityTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 10:12'!
testAddVector
	[ALBogusEntity forTesting]
		on: ALAddEntity
		do: [:n || v |
			v := n vector.
			self assert: (v at: 1) = $g.
			self assert: (v at: 2) = $p.
			self assert: (v at: 3) = $n]! !

!ALEntityTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 09:29'!
testCreation
	| bogus |
	bogus := ALBogusEntity griffle: $g plonk: $p nuft: $n.
	self assert: bogus griffle = $g.
	self assert: bogus plonk = $p.
	self assert: bogus nuft = $n.! !

!ALEntityTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 10:10'!
testCreationAdds
	self
		should: [ALBogusEntity forTesting]
		raise: ALAddEntity! !

!ALEntityTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 10:19'!
testKeyIsSet
	| entity |
	[entity := ALBogusEntity forTesting]
		on: ALAddEntity
		do: [:n | n resume: 32].
	self assert: entity key = 32.! !

!ALEntityTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 12:23'!
testReadFaultData
	| entity |
	entity := ALBogusEntity basicNew.
	entity instVarNamed: 'key' put: 1.
	[entity griffle]
		on: ALReadEntity
		do: [:n | n resume: self vector].
	self assert: entity griffle = $g.
	self assert: entity plonk = $p.
	self assert: entity nuft = $n.! !

!ALEntityTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 10:56'!
testReadFaulting
	| entity |
	entity := ALBogusEntity basicNew.
	entity instVarNamed: 'key' put: 1.
	self
		should: [entity griffle]
		raise: ALReadEntity! !

!ALEntityTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 12:25'!
testWriteFaultData
	| entity |
	entity := ALBogusEntity basicNew.
	entity instVarNamed: 'key' put: 1.
	[entity griffle: $f]
		on: ALReadEntity
		do: [:n | n resume: self vector].
	self assert: entity griffle = $f.
	self assert: entity plonk = $p.
	self assert: entity nuft = $n.! !

!ALEntityTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 10:56'!
testWriteFaulting
	| entity |
	entity := ALBogusEntity basicNew.
	entity instVarNamed: 'key' put: 1.
	self
		should: [entity griffle: $f]
		raise: ALReadEntity! !

!ALEntityTest methodsFor: 'constants' stamp: 'cwp 12/31/2012 16:33'!
vector
	^ ALVector forTesting! !

TestCase subclass: #ALRepositoryTest
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

ALRepositoryTest subclass: #ALMemoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

!ALMemoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:04'!
createRepository	
	^ ALMemoryRepository new! !

!ALRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 20:03'!
isAbstract
	^ self name = #ALRepositoryTest! !

!ALRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/27/2012 19:59'!
shouldInheritSelectors
	^ true! !

!ALRepositoryTest methodsFor: 'running' stamp: 'cwp 12/27/2012 19:58'!
setUp	
	repository := self createRepository
	! !

!ALRepositoryTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 12:40'!
testAdd
	| key vector |
	vector := self vector.
	key := repository add: vector.
	self deny: key isNil.
	self deny: vector version isNil.
	! !

!ALRepositoryTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 13:38'!
testCollect
	| keys vectors |
	keys := (1 to: 3) collect: [:i | repository add: self vector].
	vectors := repository collect: keys.
	self assert: vectors size = 3.
	vectors do: [:ea | self assert: (ea isKindOf: ALVector)]! !

!ALRepositoryTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 13:12'!
testDelete
	| key |
	key := repository add: self vector.
	repository delete: key.
	self
		should: [repository read: key]
		raise: ALStorageError! !

!ALRepositoryTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 13:03'!
testEdit
	| key v1 v2 v3 |
	v1 := self vector.
	v2 := self vector.
	v2 at: 1 put: $f.
	key := repository add: v1.
	repository edit: key vector: v2.
	v3 := repository read: key.
	self assert: v2 size = v3 size.
	1 to: v2 size do: [:i | self assert: (v2 at: i) = (v3 at: i)].
	! !

!ALRepositoryTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 13:01'!
testEditVersion
	| key v1 v2 |
	v1 := self vector.
	v2 := self vector.
	v2 at: 1 put: $f.
	key := repository add: v1.
	repository edit: key vector: v2.
	self deny: v2 version isNil.
	self deny: v2 version = v1 version! !

!ALRepositoryTest methodsFor: 'tests' stamp: 'cwp 12/31/2012 13:12'!
testRead
	| one two key |
	one := self vector.
	key := repository add: one.
	two := repository read: key.
	self assert: one size = two size.
	1 to: one size do: [:i | self assert: (one at: i) = (two at: i)].
	! !

!ALRepositoryTest methodsFor: 'constants' stamp: 'cwp 12/31/2012 16:33'!
vector
	^ ALVector forTesting! !

TestCase subclass: #ALStorageRelayTest
	instanceVariableNames: 'repository relay handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

!ALStorageRelayTest methodsFor: 'emulating' stamp: 'cwp 1/1/2013 21:30'!
handleRequest: aRequest
	^ handler value: aRequest! !

!ALStorageRelayTest methodsFor: 'running' stamp: 'cwp 1/1/2013 21:19'!
setUp
	| handler |
	repository := ALMemoryRepository new.
	relay := ALStorageRelay destination: self repository: repository.
	handler := [:request | ALResponse ok].
	! !

!ALStorageRelayTest methodsFor: 'running' stamp: 'cwp 1/2/2013 00:04'!
setUpReadOnlyHandler
	| v1 key |
	key := repository add: ALVector forTesting.
	handler := 
		[:request | 
		ALResponse type: ALContentType html callback: 
			[:out | 
			v1 := ALReadEntity key: key.
			self assert: (v1 isKindOf: ALVector)]].
	^ key! !

!ALStorageRelayTest methodsFor: 'tests' stamp: 'cwp 1/2/2013 00:01'!
testCachedReads
	"Entities read during pre-rendering are cached, so that 
	final rendering doesn't require re-reading them from the
	repository"
	
	| k1 response |
	k1 := self setUpReadOnlyHandler.
	response := relay handleRequest: (ALRequest get: ALUrl root).
	repository delete: k1.
	self
		shouldnt: [relay write: response into: nil writing]
		raise: ALStorageError
	
	! !

!ALStorageRelayTest methodsFor: 'tests' stamp: 'cwp 1/2/2013 00:04'!
testDependenciesInTransaction
	"The Etag generation pre-render is executed
	inside a transaction"
	
	| k1 |
	k1 := self setUpReadOnlyHandler.
	relay handleRequest: (ALRequest get: ALUrl root).
	! !

!ALStorageRelayTest methodsFor: 'tests' stamp: 'cwp 1/2/2013 10:04'!
testDispatchInTransaction
	"The relay executes downstream dispatch
	inside a transaction, to allow callback resources
	to work correctly."
	
	| k1 k2 v1 |
	k1 := repository add: ALVector forTesting.
	handler :=
		[:request |
		v1 := ALReadEntity key: k1.
		self assert: (v1 isKindOf: ALVector).
		k2 := ALAddEntity vector: ALVector forTesting.
		self deny: k2 isNil.
		ALResponse ok].
	relay handleRequest: (ALRequest get: ALUrl root).
	
	! !

!ALStorageRelayTest methodsFor: 'tests' stamp: 'cwp 1/2/2013 00:06'!
testGeneratesEtag
	"The relay creates an Etag header for responses that read
	entities during rendering."
	
	| response |
	self setUpReadOnlyHandler.
	response := relay handleRequest: (ALRequest get: ALUrl root).
	self assert: response hasEtag! !

!ALStorageRelayTest methodsFor: 'tests' stamp: 'cwp 1/1/2013 22:13'!
testGeneratesNoEtag
	"When the response doesn't read any entities during
	rendering, we don't generate an Etag, since it could 
	never change."
	
	| k1 response |
	k1 := repository add: ALVector forTesting.
	handler :=
		[:request |
		ALResponse type: ALContentType html callback:
			[:out]].
	response := relay handleRequest: (ALRequest get: ALUrl root).
	self deny: response hasEtag! !

!ALStorageRelayTest methodsFor: 'tests' stamp: 'cwp 1/2/2013 00:10'!
testReadOnlyRendering
	"All rendering happens in a read-only transaction,
	so that rendering cannot have side-effects in the
	repository"

	| response v1 key |
	key := repository add: ALVector forTesting.
	handler := 
		[ :request | 
		ALResponse
			type: ALContentType html
			callback: 
				[ :out | 
				v1 := ALReadEntity key: key.
				self 
					should: [v1 at: 1 put: $f]
					raise: ALImmutableError]].
	response := relay handleRequest: (ALRequest get: ALUrl root).
	relay write: response into: nil writing! !

!ALStorageRelayTest methodsFor: 'tests' stamp: 'cwp 1/2/2013 00:05'!
testRenderInTransaction
	"Final rendering of the response into the socket stream
	occurs within a transaction."

	| response |
	self setUpReadOnlyHandler.
	response := relay handleRequest: (ALRequest get: ALUrl root).
	relay write: response into: nil writing.
	! !

!ALStorageRelayTest methodsFor: 'emulating' stamp: 'cwp 1/1/2013 21:52'!
write: aMessage into: aStream
	aMessage writeInto: aStream! !

TestCase subclass: #ALTransactionTest
	instanceVariableNames: 'repository txn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

ALTransactionTest subclass: #ALReadOnlyTransactionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

!ALReadOnlyTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:41'!
setUp
	super setUp.
	txn := repository readOnlyTransaction! !

!ALReadOnlyTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:56'!
testEdit
	"Attempting to modify a vector read during
	a read-only transaction will raise an error"
	
	| key v1 |
	key := repository add: ALVector forTesting.
	txn do:
		[v1 := ALReadEntity key: key.
		self
			should: [v1 at: 1 put: $f]
			raise: ALImmutableError]! !

!ALReadOnlyTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:57'!
testHandleAdd
	"Attempting to add an entity during a read-only
	transaction will raise an error"
	
	txn do:
		[self
			should: [ALAddEntity vector: ALVector forTesting]
			raise: ALImmutableError]! !

!ALReadOnlyTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:57'!
testHandleDelete
	"Attempting to delete an entity during a transaction
	will raise an error."

	| key |
	key := repository add: ALVector forTesting.
	txn do:
		[self
			should: [ALDeleteEntity key: key]
			raise: ALImmutableError]! !

ALTransactionTest subclass: #ALReadWriteTransactionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Storage'!

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:36'!
setUp
	super setUp.
	txn := repository transaction! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:55'!
testAbortAdd
	"An entity added during an aborted transaction doesn't
	get added to the repository."

	| key v1 v2 |
	v1 := ALVector forTesting.
	txn abort: [ key := ALAddEntity vector: v1 ].
	self should: [ v2 := repository read: key ] raise: ALStorageError! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:55'!
testAbortDelete
	"An entity deleted during an aborted transaction
	is still present in the repository"

	| key v1 |
	v1 := ALVector forTesting.
	key := repository add: v1.
	txn abort: [ ALDeleteEntity key: key ].
	self shouldnt: [ repository read: key ] raise: ALStorageError! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 13:42'!
testAbortEdit
	"An entity modified during an aborted transaction
	doesn't get edited in the repository"

	| key v1 v2 |
	key := repository add: ALVector forTesting.
	txn abort:
		[v1 := ALReadEntity key: key.
		v1 at: 1 put: $f].
	v2 := repository read: key.
	self assert: (v2 at: 1) = $g. ! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/2/2013 10:18'!
testAddAbortCleanup
	"When an entity is added, then the transaction is
	aborted, we go back to the pre-add state: the key
	is nilled out, but the vector is preseved."
	
	| key vector |
	vector := ALVector forTesting.
	txn abort: [key := ALAddEntity vector: vector].
	self assert: key isNil.
	self assert: (vector isKindOf: ALVector).! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/2/2013 10:19'!
testAddCommitCleanup
	"When an add is commited, the key is preserved, 
	but the vector is nilled out so that subsequent
	accesses will trigger a read from the repository"
	
	| key vector |
	vector := ALVector forTesting.
	txn commit: [key := ALAddEntity vector: vector].
	self deny: key isNil.
	self assert: vector isNil.! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:55'!
testCommitAdd
	"An entity added during a committed transaction
	does get added to the repository"

	| key v1 v2 |
	v1 := ALVector forTesting.
	txn commit: [ key := ALAddEntity vector: v1 ].
	self shouldnt: [ v2 := repository read: key ] raise: ALStorageError! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:55'!
testCommitDelete
	"An entity delete during a committed transaction
	does get deleted from the repository"

	| key v1 |
	v1 := ALVector forTesting.
	key := repository add: v1.
	txn commit: [ key := ALDeleteEntity key: key ].
	self should: [ repository read: key ] raise: ALStorageError! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 13:44'!
testCommitEdit
	"An entity modified during a committed transaction
	does get edited in the repository"

	| key v1 v2 |
	key := repository add: ALVector forTesting.
	txn commit:
		[v1 := ALReadEntity key: key.
		v1 at: 1 put: $f].
	v2 := repository read: key.
	self assert: (v2 at: 1) = $f. ! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/2/2013 17:41'!
testDeleteAbortCleanup
	"When a delete is aborted, the key is not nilled
	out. Note that we don't care about the state of
	the vector, since that will be handled by read 
	or add cleanup."
	
	| key vector |
	vector := ALVector forTesting.
	key := repository add: vector.
	txn abort: [ALDeleteEntity key: key].
	self deny: key isNil.
! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/2/2013 17:36'!
testDeleteCommitCleanup
	"When a delete is commited, we return the entity to 
	the state it had before it was added: the key is nilled out,
	but the vector is present."
	
	| key vector |
	vector := ALVector forTesting.
	key := repository add: vector.
	txn commit: [ALDeleteEntity key: key].
	self assert: key isNil.
	self assert: (vector isKindOf: ALVector)! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:55'!
testHandleAdd
	"An AddEntity notification signaled during a transaction
	will be resumed with the key of the new entity"

	| key |
	key := txn do: [ ALAddEntity vector: ALVector forTesting ].
	self deny: key isNil! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:47'!
testHandleDelete
	| key |
	key := repository add: ALVector forTesting.
	txn do:
		[self
			shouldnt: [ALDeleteEntity key: key]
			raise: ALStorageError]! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 13:46'!
testNoChangeEdit
	"The transaction doesn't needlessly
	edit entities that haven't been modified."

	| v1 v2 k1 k2 v3 |
	k1 := repository add: ALVector forTesting.
	v1 := ALVector forTesting.
	k2 := repository add: v1.
	txn commit:
		[v2 := ALReadEntity key: k1.
		ALReadEntity key: k2.
		v2 at: 1 put: $f].
	v3 := repository read: k2.
	self assert: v1 version = v3 version! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:55'!
testReadAdded
	"Reading an entity that has been 
	added during the transaction answers
	the state vector of the new entity"

	| key v1 v2 |
	v1 := ALVector forTesting.
	txn
		abort: [ 
			key := ALAddEntity vector: v1.
			v2 := ALReadEntity key: key ].
	self assert: v1 == v2! !

!ALReadWriteTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:55'!
testReadDeleted
	"Reading an entity that has
	been deleted raises an error"

	| key |
	key := repository add: ALVector forTesting.
	txn
		abort: [ 
			ALDeleteEntity key: key.
			self should: [ ALReadEntity key: key ] raise: ALStorageError ]! !

!ALTransactionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:38'!
isAbstract
	^ self name = #ALTransactionTest! !

!ALTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:36'!
setUp
	repository := ALMemoryRepository new.! !

!ALTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:55'!
testConsistentRead
	"Two reads of the same entity will both 
	receive the same state vector, so that 
	they will have a consistent view of the
	 entity."

	| key v1 v2 v3 v4 |
	v1 := ALVector forTesting.
	key := repository add: v1.
	txn abort: 
		[v2 := ALReadEntity key: key.
		v3 := ALVector forTesting.
		v3 at: 1 put: $f.
		repository edit: key vector: v3.
		v4 := ALReadEntity key: key].
	self assert: v2 == v4! !

!ALTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/1/2013 23:55'!
testHandleRead
	"An ReadEntity notification signaled during a
	transaction will be resumed with the state
	vector of the entity"

	| key vector |
	key := repository add: ALVector forTesting.
	vector := txn do: [ ALReadEntity key: key ].
	self assert: (vector isKindOf: ALVector).
	self deny: vector version isNil! !

!ALTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/2/2013 01:31'!
testReadAbortCleanup
	| key vector |
	key := repository add: ALVector forTesting.
	txn abort: [vector := ALReadEntity key: key].
	self assert: vector isNil! !

!ALTransactionTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/2/2013 10:03'!
testReadCommitCleanup
	| key vector |
	key := repository add: ALVector forTesting.
	txn commit: [vector := ALReadEntity key: key].
	self assert: vector isNil! !

!ALVector class methodsFor: '*al-tests-storage' stamp: 'cwp 12/31/2012 16:32'!
forTesting
	^ (self new: 3)
		at: 1 put: $g;
		at: 2 put: $p;
		at: 3 put: $n;
		yourself! !
